# mzTab validation API.
# 
# This is an mzTab validation service.
# 
# OpenAPI spec version: 2.0.0
# Contact: nils.hoffmann@isas.de
# Generated by: https://github.com/swagger-api/swagger-codegen.git


#' StudyVariable Class
#'
#' @field id 
#' @field elementType 
#' @field name 
#' @field assay_refs 
#' @field average_function 
#' @field variation_function 
#' @field description 
#' @field factors 
#'
#' @importFrom R6 R6Class
#' @importFrom jsonlite fromJSON toJSON
#' @export
StudyVariable <- R6::R6Class(
  'StudyVariable',
  public = list(
    `id` = NULL,
    `elementType` = NULL,
    `name` = NULL,
    `assay_refs` = NULL,
    `average_function` = NULL,
    `variation_function` = NULL,
    `description` = NULL,
    `factors` = NULL,
    initialize = function(`id`, `elementType`, `name`, `assay_refs`, `average_function`, `variation_function`, `description`, `factors`){
      if (!missing(`id`)) {
        stopifnot(is.numeric(`id`), length(`id`) == 1)
        self$`id` <- `id`
      }
      if (!missing(`elementType`)) {
        stopifnot(is.character(`elementType`), length(`elementType`) == 1)
        self$`elementType` <- `elementType`
      }
      if (!missing(`name`)) {
        stopifnot(is.character(`name`), length(`name`) == 1)
        self$`name` <- `name`
      }
      if (!missing(`assay_refs`)) {
        stopifnot(is.list(`assay_refs`), length(`assay_refs`) != 0)
        lapply(`assay_refs`, function(x) stopifnot(R6::is.R6(x)))
        self$`assay_refs` <- `assay_refs`
      }
      if (!missing(`average_function`)) {
        stopifnot(R6::is.R6(`average_function`))
        self$`average_function` <- `average_function`
      }
      if (!missing(`variation_function`)) {
        stopifnot(R6::is.R6(`variation_function`))
        self$`variation_function` <- `variation_function`
      }
      if (!missing(`description`)) {
        stopifnot(is.character(`description`), length(`description`) == 1)
        self$`description` <- `description`
      }
      if (!missing(`factors`)) {
        stopifnot(is.list(`factors`), length(`factors`) != 0)
        lapply(`factors`, function(x) stopifnot(R6::is.R6(x)))
        self$`factors` <- `factors`
      }
    },
    toJSON = function() {
      StudyVariableObject <- list()
      if (!is.null(self$`id`)) {
        StudyVariableObject[['id']] <- self$`id`
      }
      if (!is.null(self$`elementType`)) {
        StudyVariableObject[['elementType']] <- self$`elementType`
      }
      if (!is.null(self$`name`)) {
        StudyVariableObject[['name']] <- self$`name`
      }
      if (!is.null(self$`assay_refs`)) {
        StudyVariableObject[['assay_refs']] <- lapply(self$`assay_refs`, function(x) x$toJSON())
      }
      if (!is.null(self$`average_function`)) {
        StudyVariableObject[['average_function']] <- self$`average_function`$toJSON()
      }
      if (!is.null(self$`variation_function`)) {
        StudyVariableObject[['variation_function']] <- self$`variation_function`$toJSON()
      }
      if (!is.null(self$`description`)) {
        StudyVariableObject[['description']] <- self$`description`
      }
      if (!is.null(self$`factors`)) {
        StudyVariableObject[['factors']] <- lapply(self$`factors`, function(x) x$toJSON())
      }

      StudyVariableObject
    },
    fromJSON = function(StudyVariableJson) {
      StudyVariableObject <- jsonlite::fromJSON(StudyVariableJson, simplifyVector = FALSE)
      if (!is.null(StudyVariableObject$`id`)) {
        self$`id` <- StudyVariableObject$`id`
      }
      if (!is.null(StudyVariableObject$`elementType`)) {
        self$`elementType` <- StudyVariableObject$`elementType`
      }
      if (!is.null(StudyVariableObject$`name`)) {
        self$`name` <- StudyVariableObject$`name`
      }
      if (!is.null(StudyVariableObject$`assay_refs`)) {
        self$`assay_refs` <- lapply(StudyVariableObject$`assay_refs`, function(x) {
          `assay_refsObject` <- Assay$new()
          `assay_refsObject`$fromJSON(jsonlite::toJSON(x, auto_unbox = TRUE))
          `assay_refsObject`
        })
      }
      if (!is.null(StudyVariableObject$`average_function`)) {
        `average_functionObject` <- Parameter$new()
        `average_functionObject`$fromJSON(jsonlite::toJSON(StudyVariableObject$average_function, auto_unbox = TRUE))
        self$`average_function` <- `average_functionObject`
      }
      if (!is.null(StudyVariableObject$`variation_function`)) {
        `variation_functionObject` <- Parameter$new()
        `variation_functionObject`$fromJSON(jsonlite::toJSON(StudyVariableObject$variation_function, auto_unbox = TRUE))
        self$`variation_function` <- `variation_functionObject`
      }
      if (!is.null(StudyVariableObject$`description`)) {
        self$`description` <- StudyVariableObject$`description`
      }
      if (!is.null(StudyVariableObject$`factors`)) {
        self$`factors` <- lapply(StudyVariableObject$`factors`, function(x) {
          `factorsObject` <- Parameter$new()
          `factorsObject`$fromJSON(jsonlite::toJSON(x, auto_unbox = TRUE))
          `factorsObject`
        })
      }
    },
    toJSONString = function() {
       sprintf(
        '{
           "id": %s,
           "elementType": %s,
           "name": %s,
           "assay_refs": [%s],
           "average_function": %s,
           "variation_function": %s,
           "description": %s,
           "factors": [%s]
        }',
        self$`id`,
        self$`elementType`,
        self$`name`,
        lapply(self$`assay_refs`, function(x) paste(x$toJSON(), sep=",")),
        self$`average_function`$toJSON(),
        self$`variation_function`$toJSON(),
        self$`description`,
        lapply(self$`factors`, function(x) paste(x$toJSON(), sep=","))
      )
    },
    fromJSONString = function(StudyVariableJson) {
      StudyVariableObject <- jsonlite::fromJSON(StudyVariableJson, simplifyVector = FALSE)
      self$`id` <- StudyVariableObject$`id`
      self$`elementType` <- StudyVariableObject$`elementType`
      self$`name` <- StudyVariableObject$`name`
      self$`assay_refs` <- lapply(StudyVariableObject$`assay_refs`, function(x) Assay$new()$fromJSON(jsonlite::toJSON(x, auto_unbox = TRUE)))
      ParameterObject <- Parameter$new()
      self$`average_function` <- ParameterObject$fromJSON(jsonlite::toJSON(StudyVariableObject$average_function, auto_unbox = TRUE))
      ParameterObject <- Parameter$new()
      self$`variation_function` <- ParameterObject$fromJSON(jsonlite::toJSON(StudyVariableObject$variation_function, auto_unbox = TRUE))
      self$`description` <- StudyVariableObject$`description`
      self$`factors` <- lapply(StudyVariableObject$`factors`, function(x) Parameter$new()$fromJSON(jsonlite::toJSON(x, auto_unbox = TRUE)))
    }
  )
)
